# _Synimport_

## Чем занимается?
> Добавляет контент из подготовленных файлов(_о структуре директории и файлов см. ниже_).
> Выгружает контент с сайта заполнив в правильной структуре все файлы и папки для последующего импорта.

## Требования к платформе
- _Drupal 8-10_
- _PHP 7.4.0+_

## Нужны модули
- _idna_

## Версии
- [Drupal.org prod версия](https://www.drupal.org/project/synimport)

```sh
composer require 'drupal/synimport'
```
- [Drupal.org dev версия](https://www.drupal.org/project/synimport/releases/8.x-1.x-dev)
```sh
composer require 'drupal/synimport:1.x-dev@dev
```

## Примеры файлов с контентом
Смотри папку _synimport/[content_file_examples](https://git.synapse-studio.ru/d-org/synimport/-/tree/master/content%20file%20examples)_

## Как использовать?

### Импорт

_**Все типы нод и прочего должны существовать на сайте(synimport не проверяет их на существование)**_

- **Полная версия**
```sh
cd html && drush synimport </путь/до/директории/с/файлами/контента>
```
- **Только страница контактов**
```sh
cd html && drush synimport:contact </путь/до/директории/с/файлами/контента>
```
- **Только ноды**
```sh
cd html && drush synimport:node </путь/до/директории/с/файлами/контента>
```
- **Только меню**
```sh
cd html && drush synimport:menu </путь/до/директории/с/файлами/контента>
```
- **Только термины таксономии**
```sh
cd html && drush synimport:taxonomy </путь/до/директории/с/файлами/контента>
```
- **Только товары**
```sh
cd html && drush synimport:product </путь/до/директории/с/файлами/контента>
```
- **Только блоки**
```sh
cd html && drush synimport:block </путь/до/директории/с/файлами/контента>
```
- **Только synlanding _(картинка для блоков остались вопросы и формы в подвале)_**
```sh
cd html && drush synimport:synlanding_config </путь/до/директории/с/файлами/контента>
```

### Экспорт
- /путь/до/директории/с/файлами/контента - место в которое надо выгрузить файлы (если такой папки нет, то попытается создать)
    _Все картиночки и прочие файлы, которые прикреплены к материалам он вытащит в /files от указанной директории_
- статус_публикации_материала - 1 или 0 _(тащить опубликованные или снятые с публикации)_
- тип_ноды, тип_товара, тип_блока - машинные имена сущностей 
    _Например если на сайте есть новости и статьи, но нужно тащить только статьи_
    _Если нужны все то так и указываем node, commerce_product, block_
    _То есть если у сущности есть возможность создать bundle, то можно грузить по нему или тащить все целиком указав общее машинное имя_

- **Полная версия**
```sh
cd html && drush synexport </путь/до/директории/с/файлами/контента> <статус_публикации_материала>
```
- **Только ноды**
```sh
cd html && drush synexport:node </путь/до/директории/с/файлами/контента> <тип_ноды> <статус_публикации_материала>
```
- **Только продукты**
```sh
cd html && drush synexport:product </путь/до/директории/с/файлами/контента> <тип_товара> <статус_публикации_материала>
```
- **Только термины таксономии**
```sh
cd html && drush synexport:taxonomy </путь/до/директории/с/файлами/контента> <статус_публикации_материала>
```

## Структура директории для полного импорта _(для отдельных частей просто полный путь до директории с .yml)_

**_путь_к_папке_/**:
- **_путь_к_папке_/contacts** (_.yml для страницы контактов_)
- **_путь_к_папке_/block**
- **_путь_к_папке_/node**
- **_путь_к_папке_/product**
- **_путь_к_папке_/taxonomy** (_.yml терминов таксономии(дочерние термины указываются в .yml родителя)_)
- **_путь_к_папке_/synlanding** (_.yml synlanding конфигурация для фона блоков остались вопросы и формы в подвале_)

## Структура файлов
**Если поле типизированное:**
```yml
имя_поля:
    type: тип_поля
    content: значение
```
_**Досутпные типы:**_
- **image** _(для единичных и множественных по типу field_gallery)_
- **media** 
- **attach** _(прикрепленный файл)_
- **taxonomy** _(ссылка на термин таксономии)_
- **paragraph**
- **variations** _(вариации для товаров)_
- **attribute** _(атрибут для вариации)_

_**Если указан неизвестный тип, то попытается взять как текстовое поле (описано ниже)**_

**В общем случае _(без указания типа)_ :**
```yml
имя_поля: значение
```

## Основные сервисы
- Import (_Полный импорт(выполняет все, что дальше по списку_)
- Block
- Product
- Node
- Menu (_Создание меню и ссылко в нем_)
- Taxonomy (_Обработка терминов таксономии_)

## Доп сервисы
- Logger (_Логи всех мастей (ошибки, уведомления, предупреждения)_)
- CreateEntity (_Сборка массивов для создания сущностей пришедших из сервисов по импорту_)
- Files (_Обработка файлов и медиа для загрузки на сайт_)
- Redis (_Вытаскивает данные из redis для визиток из телеги и брифов с Натриума_)
